
/* $Id: icp.h,v 1.13.2.8 1996/06/09 15:37:59 wessels Exp $ */

#ifndef ICP_H
#define ICP_H

typedef enum {
    LOG_TAG_NONE,		/* 0 */
    LOG_TCP_HIT,		/* 1 */
    LOG_TCP_MISS,		/* 2 */
    LOG_TCP_EXPIRED,		/* 3 */
    LOG_TCP_USER_REFRESH,	/* 4 */
    LOG_TCP_IFMODSINCE,		/* 5 */
    LOG_TCP_SWAPIN_FAIL,	/* 6 */
    LOG_TCP_DENIED,		/* 7 */
    LOG_UDP_HIT,		/* 8 */
    LOG_UDP_HIT_OBJ,		/* 9 */
    LOG_UDP_MISS,		/* 10 */
    LOG_UDP_DENIED,		/* 11 */
    LOG_UDP_INVALID,		/* 12 */
    ERR_READ_TIMEOUT,		/* 13 */
    ERR_LIFETIME_EXP,		/* 14 */
    ERR_NO_CLIENTS_BIG_OBJ,	/* 15 */
    ERR_READ_ERROR,		/* 16 */
    ERR_CLIENT_ABORT,		/* 17 */
    ERR_CONNECT_FAIL,		/* 18 */
    ERR_INVALID_REQ,		/* 19 */
    ERR_INVALID_URL,		/* 20 */
    ERR_NO_FDS,			/* 21 */
    ERR_DNS_FAIL,		/* 22 */
    ERR_NOT_IMPLEMENTED,	/* 23 */
    ERR_CANNOT_FETCH,		/* 24 */
    ERR_NO_RELAY,		/* 25 */
    ERR_DISK_IO,		/* 26 */
    ERR_ZERO_SIZE_OBJECT	/* 27 */
} log_type;

#define ERR_MIN ERR_READ_TIMEOUT
#define ERR_MAX ERR_ZERO_SIZE_OBJECT

/* bitfields for the icpStateData 'flags' element */
#define		REQ_HTML	0x01
#define		REQ_NOCACHE	0x02
#define		REQ_IMS		0x04
#define		REQ_AUTH	0x08
#define		REQ_CACHABLE	0x10
#define 	REQ_ACCEL	0x20
#define 	REQ_HIERARCHICAL 0x40
#define 	REQ_LOOPDETECT  0x80

typedef struct wwd {
    struct sockaddr_in address;
    char *msg;
    long len;
    struct wwd *next;
    struct timeval start;
    log_type logcode;
} icpUdpData;

extern char *icpWrite _PARAMS((int, char *, int, int, void (*handler) (), void *));
extern int icpUdpSend _PARAMS((int, char *, icp_common_t *, struct sockaddr_in *, icp_opcode, log_type));

extern int icpHandleUdp _PARAMS((int sock, void *data));
extern int asciiHandleConn _PARAMS((int sock, void *data));
extern void AppendUdp _PARAMS((icpUdpData *));

extern int neighbors_do_private_keys;
extern char *IcpOpcodeStr[];
extern int icpUdpReply _PARAMS((int fd, icpUdpData * queue));

#endif
